
#include "mocktcp.h"

#define SIZE 4096

main(int argc, char** argv)
{
	int	s, port, s2, res, count, bufsize;
	char	buf[SIZE];
	struct sockaddr_in client;

	if (argc != 2) {
		fprintf(stderr, "usage: server {port}\n");
		exit(1);
	}
	port  = atoi(argv[1]);

	fprintf(stderr, "Server waiting on port %d.\n", port);

	mt_init();

	s = mt_socket();
	if (s < 0) {
		perror("mt_socket");
		exit(1);
	}

	res = mt_bind(s, port);
	if (res < 0) {
		perror("mt_bind");
		exit(1);
	}

loop:

	fprintf(stderr, "Listening...\n");
	res = mt_listen(s);
	if (res < 0) {
		perror("mt_listen");
		exit(1);
	}

	fprintf(stderr, "Accepting...\n");
	s2 = mt_accept(s, &client);
	if (s2 < 0) {
		perror("mt_accept");
		exit(1);
	}

	fprintf(stderr, "New connection established.\n");

	bufsize = 64*1024;
	res = setsockopt(s2, SOL_SOCKET, SO_RCVBUF, &bufsize, sizeof(int));
	if (res < 0) {
		perror("setsockopt");
		exit(1);
	}

	count = 0;
	for (;;) {
		res = mt_read(s2, buf, SIZE);
		if (res < 0) {
			perror("mt_read");
			exit(1);
		}
		else if (res == 0)
			break;
		count += res;

		/*
		if (count % (SIZE*2) == 0) 
		*/
		fprintf(stderr, "%d k\n", count/1024);
	}
	fprintf(stderr, "received %d bytes.\n", count);

	fprintf(stderr, "************************************************\n");
	fprintf(stderr, "************************************************\n");

	mt_close(s2);
	
	fprintf(stderr, "done.\n");

	goto loop;
}


